from dune.perftool.generation import domain, iname, instruction, symbol, temporary_variable


@iname
def quadrature_iname():
    domain("q", "q_n")
    return "q"


def quadrature_preamble(code, **kw):
    return instruction(inames=quadrature_iname(), code=code, **kw)


@symbol
def quadrature_rule():
    return "rule"


def define_quadrature_factor(fac):
    rule = quadrature_rule()
    code = "auto {} = {}->weight();".format(fac, rule)
    return quadrature_preamble(code, assignees=fac)


@symbol
def name_quadraturepoint():
    rule = quadrature_rule()
    return "{}.position()".format(rule)


@symbol
def name_factor():
    temporary_variable("fac", shape=())
    define_quadrature_factor("fac")
    return "fac"
